/*
Caesar cipher
From Wikipedia, the free encyclopedia (http://en.wikipedia.org/wiki/Caesar_cipher)

   
In cryptography, a Caesar cipher, also known as a Caesar's cipher, the shift cipher, 
Caesar's Code or Caesar Shift, is one of the simplest and most widely-known encryption techniques. 
It is a type of substitution cipher in which each letter in the plaintext is replaced by a letter 
some fixed number of positions further down the alphabet. For example, with a shift of 3, A would 
be replaced by D, B would become E, and so on. The method is named after Julius Caesar, ,
who used it to communicate with his generals.

The encryption step performed by a Caesar cipher is often incorporated as part of more complex schemes, 
such as the Vigenre cipher, and still has modern application in the ROT13 system. 
As with all single alphabet substitution ciphers, the Caesar cipher is easily broken and in practice 
offers essentially no communication security.
----------------------------------------------------------------------------------------------------	
Author : ismail Ata Kurt
18.04.2006
*/

#include "stdafx.h"
#include "stdlib.h"

int s_ascii[]	=	{97,98,99,100,101,102,103,104,105,106,107,108,109,110,111,112,113,114,115,116,117,118,119,120,121,122};
int b_ascii[]	=	{65,66,67,68,69,70,71,72,73,74,75,76,77,78,79,80,81,82,83,84,85,86,87,88,89,90};

int caesar_crypt(char* source,char* target,int k);
	char caesar_char_crypt(char chr,int k);

int caesar_decrypt(char* source,char* target,int k);
	char caesar_char_decrypt(char chr,int k);

int main(int argc, char* argv[])
{
	int k=1;//the shift parameter, here 1, is used as the key)

	caesar_crypt("plain_text.txt","encoded_text.txt",k);//crypts plain_text.txt to encoded_text.txt
	caesar_decrypt("encoded_text.txt","new_plain_text.txt",k);//decrypts encoded_text.txt to new_plain_text.txt
    
	return 0;
}


int caesar_crypt(char* source,char* target,int k) {

	int i=0;
	int o=0;
	

	FILE *sf;//Source File
	FILE *tf;//Target File
	char temp;
	
	char *text = new char;

	

	char *sig = "{top secret}";

	if ( (sf = fopen(source, "r")) == NULL )
    {
                printf("\a\aERROR: Can't open input file!\n");
                exit(1);
    }

	while ( ( temp = fgetc(sf)) != EOF ) {
	  
		o++;
		text[o-1] = caesar_char_crypt(temp,k);
		
	
	}
	
	if ( fclose( sf ) )
                printf("\a\aERROR: Can't close source file!\n");

	if ( (tf = fopen(target, "w")) == NULL )
    {
                printf("\a\aERROR: Can't open target file!\n");
                exit(1);
    }
	
	for(i=0;i<=11;i++) {
		fputc(sig[i],tf);
	}
	for(i=0;i<=o;i++) {
		fputc(text[i],tf);
	}

	if ( fclose( tf ) )
                printf("\a\aERROR: Can't close target file!\n");


return 0;
}

int caesar_decrypt(char* source,char* target,int k) {
	
	int i=0;
	int o=0;
	
	
	
	FILE *sf;//Source File
	FILE *tf;//Target File

	char temp;
	
	char *text = new char;
	char *sig = "{top secret}";
	
	
	

	
	if ( (sf = fopen(source, "r")) == NULL )
    {
                printf("\a\aError: Can't open target file!\n");
                exit(1);
    }

	
	while ( ( temp = fgetc(sf)) != EOF ) {
	
		o++;
		
		if(o>12) {
				
				text[o-13] = caesar_char_decrypt(temp,k);
				//printf("%d\n",o-13);
			
		} else {
			if(sig[o-1]!=temp){
				printf("\a\aError: Not'a ceasar cipher encoded file!\n");
				exit(1);
			}	
		}
		

	}
	
	if ( fclose( sf ) )
                printf("\a\aError: Dosya kapatilamadi!\n");

	if ( (tf = fopen(target, "w")) == NULL )
    {
                printf("\a\aError: Can't open target file!\n");
                exit(1);
    }

	for(i=0;i<=o;i++) {
		
		fputc(text[i],tf);
	}

	if ( fclose( tf ) )
                printf("\a\aError: Can't close target file!\n");

	
return 0;
}

char caesar_char_crypt(char chr,int k) {
	
	int i=0;
	int s=0;
	char temp;


	for(i=0;i<=25;i++) {
		
			if(int(chr) == s_ascii[i]) {

				s++;
				temp =  s_ascii[((k+i) % 25)];
				break;
				
			}  
			if(int(chr) == b_ascii[i]) { 
				
				s++;
				temp =  b_ascii[((k+i) % 25)];
				break;
				
			} 
		   
			
		}

	if(s >=1) {
		return temp;
	} else { 
		return chr;
	}
}

char caesar_char_decrypt(char chr,int k) {
	
	int i=0;
	int s=0;
	char temp;
	

	for(i=0;i<=25;i++) {
		
			if(int(chr) == s_ascii[i]) {

				s++;
				temp =  s_ascii[((i-k) % 25)];
				break;
				
				
			}  
			if(int(chr) == b_ascii[i]) { 
				
				s++;
				temp =  b_ascii[((i-k) % 25)];
				break;
				
			} 
		   
			
		}

	if(s >=1) {
		return temp;
	} else { 
		return chr;
	}
}
